//---------------------------------------------------------------------------

#ifndef fakefra2_Unit1H
#define fakefra2_Unit1H
#define nFracTypes 2
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <math.h>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TButton *Button1;
        TLabel *Label1;
        TEdit *eMaxLength;
        TLabel *Label2;
        TEdit *eSide;
        TImage *Image1;
        TEdit *eRcRange;
        TLabel *rcRangeLabel;
        TEdit *eInterval;
        TLabel *Label3;
        TEdit *eNWorms;
        TLabel *Label4;
        TTimer *chaosTimer;
        TCheckBox *CBWhite;
        TCheckBox *CBBoundaries;
        TCheckBox *CBWormhate;
        TLabel *Label5;
        TEdit *eFadeFactor;
        TCheckBox *CBCircular;
        TCheckBox *CBSingle;
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall chaosTimerTimer(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
        class cWorm
        {
                public:
                cWorm();
                float
                        * points,
                        rc,
                        rcRange,
                        startVal;
                int
                        width,
                        height,
                        lineRow,
                        lineColumn,
                        maxLength;
                int indexOf(int r, int c);
                void adjust();
                void define(int argwidth, int argheight, int argmaxLength, float argrcRange);
                void init();
                void recurse1(float lastVal, int lineRow, int lineColumn, int lengthLeft,
                        float & rc, int lastDR, int lastDC);
                void checkBoundaries(int & row, int & column);
                void checkValue(float & val);
        };
        class cWormDance
        {
                public:
                cWormDance(int argnWorms, TImage * & argimage, int argside);
                TImage
                        * image;
                cWorm
                        * worm;
                int
                        nWorms,
                        side,
                        width,
                        height;
                void wormLove();
                void draw();
                void fade();
                TColor getColor(float val, int n);
        };
        cWormDance
                *wormDance;
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
